﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Collections.Generic;

namespace Regular.Test
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestMethod1()
        {
            List<int> vysledky = new List<int>();
            List<string> regVyrazy = new List<string>();
            List<string> vstupy = new List<string>();
            
            //0
            regVyrazy.Add("Petr");
            vstupy.Add("Vcera jsem byl s Petrou");

            regVyrazy.Add("[a-z]k");
            vstupy.Add("trakar");

            regVyrazy.Add("vr+");
            vstupy.Add("vrrrrr");

            regVyrazy.Add("vr+");
            vstupy.Add("vratnice");

            regVyrazy.Add("vr+");
            vstupy.Add("vana");
            //5
            regVyrazy.Add("vr?a");
            vstupy.Add("vrah");

            regVyrazy.Add("vr?a");
            vstupy.Add("vana");

            regVyrazy.Add("vr?a");
            vstupy.Add("vrrrrr");

            regVyrazy.Add("m[^h-z]");
            vstupy.Add("mazat");

            regVyrazy.Add("m[^h-z]");
            vstupy.Add("umucit");
            //10
            regVyrazy.Add("^stre");
            vstupy.Add("na strese");

            regVyrazy.Add("^stre");
            vstupy.Add("prostredi");

            regVyrazy.Add("[a-zA-Z0-9 ]*");
            vstupy.Add("jakykoliv text");

            regVyrazy.Add("[a-Z]");
            vstupy.Add("b");

            regVyrazy.Add("[a-9]");
            vstupy.Add("t");
            //15
            regVyrazy.Add("[a-tABC0-2 ]");
            vstupy.Add("1");

            regVyrazy.Add("[a-z ]");
            vstupy.Add(" ");

            regVyrazy.Add("[a-z]m[a-z]");
            vstupy.Add("bmw");

            regVyrazy.Add("fr*d?[^d-z]");
            vstupy.Add("frrrdc");
            
            regVyrazy.Add("");
            vstupy.Add("ahoj 007");
            //20
            regVyrazy.Add("^kol[ab]*d?");
            vstupy.Add("kolabba");

            regVyrazy.Add("k[abe]a+b$");
            vstupy.Add("keab");

            regVyrazy.Add("k[abe]a+b$");
            vstupy.Add("kaabr");
            
            regVyrazy.Add("^[:upper:][:lower:]* [:upper:][:lower:]* [:num:]*");
            vstupy.Add("James Bond 007");
            
            regVyrazy.Add("a[^a-g]cd$");
            vstupy.Add("slovo ahcd");
            //25
            regVyrazy.Add("a[^a-g]cd$");
            vstupy.Add("slovo a6cde");

            regVyrazy.Add("^[^a-j]");
            vstupy.Add("cola");
            
            regVyrazy.Add("^[^a-j]");
            vstupy.Add("karlik");
            //28
            regVyrazy.Add("[:alnum:]?g");
            vstupy.Add("g");

            Regular r;

            for (int i = 0; i < regVyrazy.Count; i++)
            {
                r = new Regular(regVyrazy[i]);
                vysledky.Add(r.VlozVstup(vstupy[i]));
            }

            Assert.AreEqual(0, vysledky[0]);
            Assert.AreEqual(0, vysledky[1]);
            Assert.AreEqual(0, vysledky[2]);
            Assert.AreEqual(0, vysledky[3]);
            Assert.AreEqual(1, vysledky[4]);
            Assert.AreEqual(0, vysledky[5]);
            Assert.AreEqual(0, vysledky[6]);
            Assert.AreEqual(1, vysledky[7]);
            Assert.AreEqual(0, vysledky[8]);
            Assert.AreEqual(1, vysledky[9]);
            Assert.AreEqual(0, vysledky[10]);
            Assert.AreEqual(1, vysledky[11]);
            Assert.AreEqual(0, vysledky[12]);
            Assert.AreEqual(2, vysledky[13]);
            Assert.AreEqual(2, vysledky[14]);
            Assert.AreEqual(0, vysledky[15]);
            Assert.AreEqual(0, vysledky[16]);
            Assert.AreEqual(0, vysledky[17]);
            Assert.AreEqual(0, vysledky[18]);
            Assert.AreEqual(0, vysledky[19]);
            Assert.AreEqual(0, vysledky[20]);
            Assert.AreEqual(0, vysledky[21]);
            Assert.AreEqual(1, vysledky[22]);
            Assert.AreEqual(0, vysledky[23]);
            Assert.AreEqual(0, vysledky[24]);
            Assert.AreEqual(1, vysledky[25]);
            Assert.AreEqual(1, vysledky[26]);
            Assert.AreEqual(0, vysledky[27]);
            Assert.AreEqual(0, vysledky[28]);

        }
    }
}
