/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package regularnivyrazy;

import java.util.ArrayList;
import java.util.Arrays;
/**
 *
 * @author Krupi
 */
public class Pismeno {
    private ArrayList<Character> znaky = new ArrayList();
    private boolean konecSlova = false;
    private boolean neomezeneOpakovani = false;
    private boolean moznostVynechat = false;
    private boolean opakovano = false;
    private boolean rozpeti = false;
    private String definovanaMnozina;
    private char aktualniZnak;
    protected Pismeno(char znak){
        znaky.add(znak);
        aktualniZnak = znak;
    }
    public Pismeno(){
        definovanaMnozina = "";
    }
    public int zkontrolovat(char c){
        if(znaky.contains(c)){
            if(neomezeneOpakovani){
                opakovano = true;
                return 2;
            }
            if(konecSlova)
                return 4;
                
            return 0;
        }
        else {
            if(moznostVynechat || opakovano)
                return 3;
            return 1;
        }
    }
    public int pridatZnak(char znak){
        if(rozpeti && !(Validovac.validniZnaky.contains(String.valueOf(aktualniZnak)) && Validovac.validniZnaky.contains(String.valueOf(znak))))
            return 1;
        if(definovanaMnozina != null && znak != ':'){
            definovanaMnozina += znak;
        }
        else
            switch(znak){
                case '+':
                    neomezeneOpakovani = true;
                    break;
                case '*':
                    neomezeneOpakovani = true;
                    moznostVynechat = true;
                    break;
                case '?':
                    moznostVynechat = true;
                    break;
                case '-':
                    if(!(aktualniZnak == ' '))
                        rozpeti = true;
                    else
                        return 1;
                    break;
                case ':':
                    if(getDefinovanaMnozina() == null){
                        return 1;
                    }
                    else{
                        String s = "";
                        switch(definovanaMnozina){
                            case "alpha":
                                s += Validovac.low + Validovac.upp;
                                break;
                            case "upper":
                                s += Validovac.upp;
                                break;
                            case "lower":
                                s += Validovac.low;
                                break;
                            case "num":
                                s += Validovac.cisla;
                                break;
                            case "alnum":
                                s += Validovac.cisla + Validovac.low + Validovac.upp;
                                break;
                        }
                        for(char c : s.toCharArray()){
                            znaky.add(c);
                        }
                    }
                    break;
                case '$':
                    konecSlova = true;
                    break;
                default:
                    if(rozpeti){
                        if((int)aktualniZnak < (int)znak){
                            String[] skupiny = {Validovac.low, Validovac.upp, Validovac.cisla};
                            boolean b = true;
                            for(String s : skupiny){
                                if(s.contains(String.valueOf(aktualniZnak)) && s.contains(String.valueOf(znak))){
                                    b = false;
                                    for(int i = aktualniZnak; i <= znak; i++){
                                        znaky.add((char)i);
                                    }
                                }
                            }
                            if(b)
                                return 1;
                            rozpeti = false;
                            aktualniZnak = ' ';
                        }
                        else
                            return 1;
                    }
                    else{
                        aktualniZnak = znak;
                        znaky.add(znak);
                    }
                    break;
            }
        return 0;
    }

    /**
     * @return the definovanaMnozina
     */
    public String getDefinovanaMnozina() {
        return definovanaMnozina;
    }
    public void prevratit(){
        ArrayList<Character> novy = new ArrayList<>();
        for(char c : Validovac.validniZnaky.toCharArray()){
            novy.add(c);
        }
        novy.removeAll(znaky);
        znaky = novy;
    }
}
