#ifndef VECTOR_H
#define VECTOR_H

#include <vector>
#include <cstdint>

template<typename T>
class Vector: public std::vector<T>{
public:

	inline bool includes(T t){
		uint32_t i;
		for(i=0;i<this->size();++i)
			if((*this)[i]==t)return 1;
		return 0;
	}
	inline void addNew(T t){
		if(!includes(t))this->push_back(t);
	}
	inline bool remove(T t){
		uint32_t i;
		bool ret=0;
		for(i=0;i<this->size();++i){
			if((*this)[i]==t){
				this->erase(this->begin()+i);
				--i;
				ret=1;
			}
		}
		return ret;		
	}
private:
};

#endif
