#include "cmpChars.h"

uint32_t CmpChars::init(char *set, uint32_t len){
	uint32_t i=0;
	if(len && set[i]=='^'){
		negate=1;
		++i;
	}else{
		negate=0;
	}

	if(!strncmp(set+i, ":alpha:]", strlen(":alpha:]"))){
		push_range('a', 'z');
		push_range('A', 'Z');
	}else if(!strncmp(set+i, ":upper:]", strlen(":upper:]"))){
		push_range('A', 'Z');
	}else if(!strncmp(set+i, ":lower:]", strlen(":lower:]"))){
		push_range('a', 'z');
	}else if(!strncmp(set+i, ":num:]", strlen(":num:]"))){
		push_range('0', '9');
	}else if(!strncmp(set+i, ":alnum:]", strlen(":alnum:]"))){
		push_range('a', 'z');
		push_range('A', 'Z');
		push_range('0', '9');
	}else for(;i<len;++i){
		if(set[i]=='-'){
			if(i && set[i-1] <= set[i+1]){

				if(set[i-1]>='0' && set[i-1]<='9'){
					if(set[i+1]>='0' && set[i+1]<='9'){
						push_range(set[i-1], set[i+1]);
					}else return ERROR;

				}else if(set[i-1]>='A' && set[i-1]<='Z'){
					if(set[i+1]>='A' && set[i+1]<='Z'){
						push_range(set[i-1], set[i+1]);
					}else return ERROR;

				}else if(set[i-1]>='a' && set[i-1]<='z'){
					if(set[i+1]>='a' && set[i+1]<='z'){
						push_range(set[i-1], set[i+1]);
					}else return ERROR;

				}else return ERROR;
			}else return ERROR;
			++i;
		}else if((set[i]>='A' && set[i]<='Z') || (set[i]>='a' && set[i]<='z') || (set[i]>='0' && set[i]<='9') || set[i]==' '){
			valid.addNew(set[i]);
		}else return ERROR;
	}

	return YES;
}

void CmpChars::push_range(char a, char b){
	for(;a<=b;++a){
		valid.addNew(a);
	}
}

bool CmpChars::validate(char c){
	bool includes = valid.includes(c);

	return !(negate != includes);

	//return negate?includes:!includes;
}

uint32_t CmpChars::check(char *input){
	uint32_t i=0;

	for(;i<min;++i){
		if(validate(input[i]))return NO;
	}

	if(!next)
		return YES;

	for(;i<max;++i){
		if(!next->check(input+i))return YES;
		if(validate(input[i]))return NO;
	}
	if(!next->check(input+i))return YES;
	else return NO;
}
