﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Regular
{
    public class Hrana
    {
        /// <summary>
        /// Znak, který tuto hranu odpálí
        /// </summary>
        public char Znak { get; set; }

        /// <summary>
        /// Číslo stavu do kterého se automat po odpálení této hrany přesune
        /// </summary>
        public int NasledujiciStav { get; set; }

        /// <summary>
        /// Nová hrana
        /// </summary>
        /// <param name="znak">Znak, který tuto hranu odpálí</param>
        /// <param name="cisloNasledujicihoStavu">Číslo stavu do kterého se automat po odpálení této hrany přesune</param>
        public Hrana(char znak, int cisloNasledujicihoStavu)
        {
            this.Znak = znak;
            this.NasledujiciStav = cisloNasledujicihoStavu;
        }

    }
}