#ifndef REGEXOBJECT_H
#define REGEXOBJECT_H

#include "common.h"

class RegexObject{
public:
	RegexObject():next(0), min(1), max(1){}
	virtual ~RegexObject(){if(next)delete next;}

	void setNext(RegexObject *next){this->next = next;}
	void setMin(uint32_t min){this->min=min;}
	void setMax(uint32_t max){this->max=max;}

	virtual uint32_t check(char *input){if(next)return next->check(input); return YES;}
protected:
	RegexObject *next;

	uint32_t min;
	uint32_t max;
};

#endif
